/**
 * Check whether a component is external package, e.g. @ali/uxcore
 * @param path Component path
 */
export declare function isPackagePath(path: string): boolean;
/**
 * Title cased string
 * @param s original string
 */
export declare function toTitleCase(s: string): string;
/**
 * Make up an import name/tag for components
 * @param path Original path name
 */
export declare function generateComponentName(path: string): string;
/**
 * normalizing import path for easier comparison
 */
export declare function getNormalizedImportPath(path: string): string;
/**
 * make a relative path
 *
 * @param toPath abolute path
 * @param fromPath absolute path
 */
export declare function makeRelativePath(toPath: string, fromPath: string): string;
/**
 * Resolve component with absolute path to relative path
 * @param path absolute path of component from project
 */
export declare function resolveAbsoluatePath(path: string, base: string): string;
export declare function joinPath(...segments: string[]): string;
export declare function removeVersion(path: string): string;
