import { IPublicModelScrollTarget, IPublicTypeScrollable, IPublicModelScroller } from '@alilc/lowcode-types';
export interface IScrollTarget extends IPublicModelScrollTarget {
}
export declare class ScrollTarget implements IScrollTarget {
    private target;
    get left(): number;
    get top(): number;
    private doc?;
    constructor(target: Window | Element);
    scrollTo(options: {
        left?: number;
        top?: number;
    }): void;
    scrollToXY(x: number, y: number): void;
    get scrollHeight(): number;
    get scrollWidth(): number;
}
export interface IScroller extends IPublicModelScroller {
}
export declare class Scroller implements IScroller {
    private pid;
    scrollable: IPublicTypeScrollable;
    constructor(scrollable: IPublicTypeScrollable);
    get scrollTarget(): IScrollTarget | null;
    scrollTo(options: {
        left?: number;
        top?: number;
    }): void;
    scrolling(point: {
        globalX: number;
        globalY: number;
    }): void;
    cancel(): void;
}
