import { Logger } from '@alilc/lowcode-utils';
import { ILowCodePluginRuntime, ILowCodePluginManager } from './plugin-types';
import { IPublicTypePluginConfig, IPublicTypePluginMeta } from '@alilc/lowcode-types';
export declare class LowCodePluginRuntime implements ILowCodePluginRuntime {
    config: IPublicTypePluginConfig;
    logger: Logger;
    private manager;
    private _inited;
    private pluginName;
    meta: IPublicTypePluginMeta;
    /**
     * 标识插件状态，是否被 disabled
     */
    private _disabled;
    constructor(pluginName: string, manager: ILowCodePluginManager, config: IPublicTypePluginConfig, meta: IPublicTypePluginMeta);
    get name(): string;
    get dep(): any;
    get disabled(): boolean;
    isInited(): boolean;
    init(forceInit?: boolean): Promise<void>;
    destroy(): Promise<void>;
    setDisabled(flag?: boolean): void;
    toProxy(): this;
    dispose(): Promise<void>;
}
