import { Point, ScrollTarget } from '../designer';
import { AutoFit, IViewport } from '../simulator';
export default class Viewport implements IViewport {
    private rect?;
    private _bounds?;
    get bounds(): DOMRect;
    get contentBounds(): DOMRect;
    private viewportElement?;
    constructor();
    mount(viewportElement: HTMLElement | null): void;
    touch(): void;
    get height(): number;
    set height(newHeight: number);
    get width(): number;
    set width(newWidth: number);
    private _scale;
    /**
     * 缩放比例
     */
    get scale(): number;
    set scale(newScale: number);
    private _contentWidth;
    private _contentHeight;
    get contentHeight(): number | AutoFit;
    set contentHeight(newContentHeight: number | AutoFit);
    get contentWidth(): number | AutoFit;
    set contentWidth(val: number | AutoFit);
    private _scrollX;
    private _scrollY;
    get scrollX(): number;
    get scrollY(): number;
    private _scrollTarget?;
    /**
     * 滚动对象
     */
    get scrollTarget(): ScrollTarget | undefined;
    private _scrolling;
    get scrolling(): boolean;
    setScrollTarget(target: Window): void;
    toGlobalPoint(point: Point): Point;
    toLocalPoint(point: Point): Point;
}
