"use strict";

exports.__esModule = true;
exports.filterValidOptions = filterValidOptions;
exports.isLowCodeRegisterOptions = isLowCodeRegisterOptions;
exports.isValidPreferenceKey = isValidPreferenceKey;
var _lodash = require("lodash");
function isValidPreferenceKey(key, preferenceDeclaration) {
  if (!preferenceDeclaration || !Array.isArray(preferenceDeclaration.properties)) {
    return false;
  }
  return preferenceDeclaration.properties.some(function (prop) {
    return prop.key === key;
  });
}
function isLowCodeRegisterOptions(opts) {
  return opts && ('autoInit' in opts || 'override' in opts);
}
function filterValidOptions(opts, preferenceDeclaration) {
  if (!opts || !(0, _lodash.isPlainObject)(opts)) return opts;
  var filteredOpts = {};
  Object.keys(opts).forEach(function (key) {
    if (isValidPreferenceKey(key, preferenceDeclaration)) {
      var v = opts[key];
      if (v !== undefined && v !== null) {
        filteredOpts[key] = v;
      }
    }
  });
  return filteredOpts;
}