import Viewport from '../builtin-simulator/viewport';
import { ISimulatorHost } from '../simulator';
export declare function isElementNode(domNode: Element): boolean;
/**
 * 判断节点是否在 viewport 内，判断依据：只要节点有一部分在 viewport 内，都算 true，其余情况 false
 * @param domNode 待检测的节点
 * @param viewport 画布 viewport
 * @returns 是否在 viewport 内
 */
export declare function isDOMNodeVisible(domNode: Element, viewport: Viewport): boolean;
/**
 * normalize triggers
 * @param triggers
 */
export declare function normalizeTriggers(triggers: string[]): string[];
/**
 * make a handler that listen all sensors:document, avoid frame lost
 */
export declare function makeEventsHandler(boostEvent: MouseEvent | DragEvent, sensors: ISimulatorHost[]): (fn: (sdoc: Document) => void) => void;
